﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
//using System.Windows.Shapes;
using System.Windows.Threading;
using Steema.TeeChart.WPF;
using Steema.TeeChart.WPF.Drawing;
using Steema.TeeChart.WPF.Styles;
using Steema.TeeChart.WPF.Tools;

namespace WpfScroll
{
    /// <summary>
    /// Interaction logic for WindowScroll.xaml
    /// </summary>
    public partial class WindowScroll : Window
    {
        public class TrendData
        {
            public DateTime DateTime { get; set; }
            public double? Value { get; set; }
            public Color LineColor { get; set; } = Colors.Black;
            public TrendData(DateTime _DateTime, double? _Value, Color? lineColor = null)
            {
                DateTime = _DateTime;
                Value = _Value;
                if (lineColor != null)
                {
                    LineColor = lineColor.Value;
                }
            }



        }
        List<TrendData> Points = new List<TrendData>();
        public WindowScroll()
        {
            InitializeComponent();

            DateTime dddt = DateTime.MinValue;

            DateTime dt11 = DateTime.Now.AddDays(-30);

            DateTime dtNow = DateTime.Now;
            TimeSpan tsp = dtNow.Subtract(dt11);


            scrollBarBottom.Loaded += scrollBarBottom_Loaded;
            IntializeChart();
            this.SizeChanged += Window23_SizeChanged;
            previoustotalMins = totalMins;
            tChart1.GetAxisLabel += tChart1_GetAxisLabel;
            DateTime dt1 = DateTime.Now;
            DateTime dt2 = DateTime.Now.AddMinutes(1440);
            TimeSpan dt3 = dt1.Subtract(dt2);
            if (dt1 > dt2)
            {

            }
            Typeface typeface = new Typeface(this.FontFamily,
            this.FontStyle,
            this.FontWeight,
            this.FontStretch);

            FormattedText formmatedText = new FormattedText(
            btnStartPause.Content.ToString(),
            System.Threading.Thread.CurrentThread.CurrentCulture,
            this.FlowDirection,
            typeface,
            this.FontSize,
            this.Foreground);

            TrendVisible trendVisible = new TrendVisible() { Visible = TrendVisibility.Visible };

            scrollBarBottom.Visibility = trendVisible.Visible == TrendVisibility.Visible ? Visibility.Visible : trendVisible.Visible == TrendVisibility.Collapsed ? Visibility.Collapsed : Visibility.Hidden;
            backgroundWorker = new BackgroundWorker();
            backgroundWorker.DoWork += backgroundWorker_DoWork;
            backgroundWorker.RunWorkerCompleted += backgroundWorker_RunWorkerCompleted;

            DependencyPropertyDescriptor dpPropertyDescriptor = DependencyPropertyDescriptor.FromProperty(ScrollViewer.HorizontalOffsetProperty, scrollBarBottom.GetType());
            dpPropertyDescriptor.AddValueChanged(scrollBarBottom, (sender, args) =>
            {
                TimeSpan tsp1 = ViewStartTime.Subtract(Points[0].DateTime);
                //txtTest.Text =txtTest.Text+":"+ scrollBarBottom.HorizontalOffset.ToString()+":";
                if (tsp1 <= new TimeSpan(30, 0, 0))
                {

                    //MessageBox.Show("" + tsp1.ToString());
                }
            });
        }

        void backgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            string dateString = DateTime.Now.ToString("o");
            txtTest.Text = dateString + " Count:" + count;
        }
        long count = 0;
        void backgroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            //this.Dispatcher.BeginInvoke(new textupdater(UpdateText), DispatcherPriority.Render, null);

            DateTime dtArgs = (DateTime)e.Argument;
            try
            {

                string dateTimeString = dtArgs.ToString("g");
                bool bFound = Points.Exists(x => x.DateTime.ToString("g") == dateTimeString);
                if (bFound)
                {
                    //MessageBox.Show(bFound.ToString() + ":" + dateTimeString);
                }
                for (int i = 0; i < 10000000; i++)
                {
                    //txtTest.Text = "";
                    count++;
                    //this.Dispatcher.BeginInvoke(new Action(() => txtTest.Text=i.ToString()), DispatcherPriority.Background);



                }
                Thread.Sleep(new TimeSpan(0, 0, 5));
            }
            catch (Exception ex)
            {

            }
        }

        void tChart1_GetAxisLabel(object sender, GetAxisLabelEventArgs e)
        {
            if (sender == tChart1.Axes.Left)
            {
                ((Axis)sender).Labels.Font.Color = Colors.Red;
            }
        }

        public class TrendVisible
        {
            public TrendVisibility Visible { get; set; }
        }
        public enum TrendVisibility
        {
            Visible = 0,
            Hidden = 1,
            Collapsed = 2,
        }

        void Window23_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);

            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;
            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;
            //canvasTop.Width = tChart1.Chart.ChartRect.Width;
            oneMinWidth = tChart1.Chart.ChartRect.Width / totalMins;
            //brdInsideScroll.Width = oneYearMins * oneMinWidth + (((totalMins / 4) * oneMinWidth));
            brdInsideScroll.Width = (tsp.TotalMinutes * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
            TimeSpan time = ViewStartTime.Subtract(TrendWidgetStartTime);
            scrollBarBottom.ScrollToHorizontalOffset(time.TotalMinutes * oneMinWidth);
            tChart1.Axes.Bottom.SetMinMax(ViewStartTime.ToOADate(), ViewStartTime.AddMinutes(totalMins).ToOADate());
            UpdateStartEndDate(ViewStartTime, ViewStartTime.AddMinutes(totalMins));
        }
        void scrollBarBottom_Loaded(object sender, RoutedEventArgs e)
        {
            IntializeScroll();
            //line.DataSource = Points;
            line.Invalidate();
        }

        bool IsSizeChanging = true;
        bool isTrendLoaded;
        double totalMins = 60;
        double oneMinWidth = 0;
        double onedayMins = 1440;
        int oneHourMins = 60;
        double oneDayWidth = 0;
        double oneYearMins = 1440 * 1;
        double ScrollYearMins = 1440 * 1;
        double HISTORYREADHOURS = 2160;
        private DateTime TrendWidgetStartTime;
        double previoustotalMins;

        private void IntializeScroll()
        {
            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;

            IsSizeChanging = true;
            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;
            oneMinWidth = tChart1.Chart.ChartRect.Width / totalMins;
            oneDayWidth = oneMinWidth * onedayMins;
            brdInsideScroll.Width = (ScrollYearMins * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
            pastCursorTool.XValue = DateTime.Now.ToOADate();
            currentCursorTool.XValue = DateTime.Now.ToOADate();
            TrendWidgetStartTime = DateTime.Now.AddMinutes(-ScrollYearMins);
            TrendWidgetEndTime = DateTime.Now.AddMinutes(((totalMins / 4)));

            ViewStartTime = DateTime.Now.AddMinutes(-((totalMins / 4) * 3));
            ViewEndTime = DateTime.Now.AddMinutes(((totalMins / 4)));

            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
            UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));
            scrollBarBottom.ScrollToRightEnd();

            isScrollAtEnd = true;

            DateTime dt = TrendWidgetStartTime.AddMinutes((scrollBarBottom.ExtentWidth) / oneMinWidth);
        }

        Line line1 = new Line();
        //FastLine line = new FastLine();
        Line line = new Line();
        double i = 0;
        Random rnd = new Random();
        CursorTool pastCursorTool;
        CursorTool currentCursorTool;
        DispatcherTimer timer;
        DateTime ViewStartTime;
        DateTime ViewEndTime;
        private DateTime TrendWidgetEndTime;


        double ONE_YEAR = 365 * 1440;
        double TREND_CAPACITY = 3;
        DateTime TR_START_TIME;
        DateTime TR_END_TIME=DateTime.Now;
        void IntializeChart()
        {
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0,0,1);
            timer.Tick += timer_Tick;
            timer.Start();
            //Line line = new Line();
            Random Rnd = new Random();
            tChart1.Aspect.View3D = false;
            tChart1.Zoom.Allow = false;
            tChart1.Series.Add(line);
            line.Tag = "Temp";
            line.XValues.DateTime = true;
            //line.Pointer.Visible = false;
            line.Color = Colors.Red;
            line.TreatNulls = TreatNullsStyle.DoNotPaint;
            //line.IgnoreNulls = false;
            line.LinePen.Width = 5;
            line.SetNull(0);
            line.XValues.DataMember = "DateTime";
            line.YValues.DataMember = "Value";
            int POINTS_COUNT = (int)HISTORYREADHOURS * 60;
            TR_START_TIME = DateTime.Now.AddHours(-HISTORYREADHOURS);
            //Points.Add(new TrendData(DateTime.Now.AddSeconds((0)), double.NaN,Colors.Transparent));
            for (int i = POINTS_COUNT; i >= 0; i--)
            {
                int n = data;
                if (data == 50) data = 70;
                else data = 50;
                //if (n % 10 == 0)
                //{
                //    line.Add(DateTime.Now.AddMinutes(-i), (double?)null, Colors.Blue);
                //    //line.Add(DateTime.Now.AddMinutes(-i), n, Colors.Blue);


                //}
                //else
                //{
                //    line.Add(DateTime.Now.AddMinutes(-i), n, Colors.Green);
                //}
                Points.Add(new TrendData(DateTime.Now.AddSeconds(-(i*1)), n));
            }
            line.DataSource = Points;
            //line.Invalidate();
            DateTime dt = DateTime.Now.AddMinutes(-20);
            tChart1.Axes.Bottom.Minimum = dt.ToOADate();
            tChart1.Axes.Bottom.Maximum = DateTime.Now.AddHours(1).ToOADate();

            tChart1.Axes.Bottom.Minimum = new DateTime(2013, 01, 01, 00, 00, 00).ToOADate();
            tChart1.Axes.Bottom.Maximum = new DateTime(2013, 01, 02, 00, 00, 00).ToOADate();

            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-30), DateTime.Now.AddMinutes(15));
            UpdateStartEndDate(DateTime.Now.AddMinutes(-30), DateTime.Now.AddMinutes(15));

            tChart1.Axes.Bottom.Increment = Steema.TeeChart.WPF.Utils.GetDateTimeStep(Steema.TeeChart.WPF.DateTimeSteps.FiveMinutes);


            tChart1.Axes.Bottom.AutomaticMaximum = false;
            tChart1.Axes.Left.SetMinMax(0, 200);
            //tChart1.Axes.Left.Increment = 40;
            tChart1.Axes.Bottom.StartPosition = 0;




            tChart1.Header.Visible = false;

            tChart1.Legend.Visible = false;
            tChart1.Aspect.View3D = false;


            tChart1.Axes.Left.AxisPen.Width = 5;
            tChart1.Axes.Bottom.AxisPen.Width = 1;
            tChart1.Axes.Left.OtherSide = true;
            tChart1.Axes.Left.MinorTicks.Visible = false;
            tChart1.Axes.Bottom.MinorTicks.Visible = false;


            tChart1.Axes.Left.Ticks.Visible = false;
            tChart1.Axes.Bottom.Ticks.Visible = false;
            tChart1.Axes.Bottom.Ticks.Visible = true;

            tChart1.Axes.Bottom.Ticks.Color = Colors.Transparent;
            tChart1.Axes.Bottom.Ticks.Length = 5;


            tChart1.Walls.Back.Visible = true;
            tChart1.Walls.Back.Color = (Color)ColorConverter.ConvertFromString("#FFF0F0F0");
            tChart1.Walls.Back.Gradient.Visible = false;
            tChart1.Walls.Back.Pen.Width = 1;
            tChart1.Walls.Back.Pen.Color = Colors.Black;
            tChart1.Axes.Left.Ticks.Visible = false;
            tChart1.Axes.Bottom.Grid.Visible = true;


            tChart1.Panel.Gradient.Visible = false;
            tChart1.Panel.Color = Colors.Transparent;
            tChart1.Panel.Gradient.StartColor = Colors.LightGray;
            tChart1.Panel.Gradient.EndColor = Colors.LightGray;
            tChart1.Axes.Bottom.Grid.Style = DashStyles.Solid;
            tChart1.Axes.Left.Grid.Style = DashStyles.Solid;
            tChart1.Panel.Bevel.Outer = BevelStyles.None;
            tChart1.Panel.Bevel.Inner = BevelStyles.None;

            tChart1.Axes.Bottom.Labels.Style = AxisLabelStyle.Value;
            tChart1.Axes.Bottom.Labels.Width = 100;
            tChart1.Axes.Left.Automatic = false;
            tChart1.Axes.Left.Minimum = 10.00;
            tChart1.Axes.Left.Maximum = 100.00;
            tChart1.Panel.MarginBottom = 0;
            tChart1.Panel.MarginLeft = 0;
            tChart1.Panel.MarginRight = 0;
            tChart1.Panel.MarginTop = 0;

            tChart1.Panel.BevelInner = Steema.TeeChart.WPF.Drawing.BevelStyles.None;
            tChart1.Panel.BevelOuter = Steema.TeeChart.WPF.Drawing.BevelStyles.None;

            //tChart1.Axes.Left.AxisPen.Color = Colors.Red;
            //tChart1.Axes.Left.AxisPen.Width = 1;

            //tChart1.Axes.Bottom.AxisPen.Color = Colors.Red;
            //tChart1.Axes.Bottom.AxisPen.Width = 1;

            currentCursorTool = new CursorTool();
            tChart1.Tools.Add(currentCursorTool);
            currentCursorTool.Active = true;
            currentCursorTool.Style = CursorToolStyles.Vertical;
            currentCursorTool.Pen.Style = DashStyles.Solid;
            currentCursorTool.Pen.Width = 2;
            currentCursorTool.Pen.Color = System.Windows.Media.Brushes.RoyalBlue.Color;
            currentCursorTool.Active = true;


            pastCursorTool = new CursorTool();
            pastCursorTool.FollowMouse = false;
            pastCursorTool.Active = true;
            pastCursorTool.Style = CursorToolStyles.Vertical;
            pastCursorTool.Pen.Style = DashStyles.Solid;
            pastCursorTool.Pen.DrawingPen.StartLineCap = PenLineCap.Round;
            tChart1.Tools.Add(pastCursorTool);
            pastCursorTool.Change += PastCursorTool_Change;
            pastCursorTool.Pen.Width = 2;
            pastCursorTool.Pen.Color = System.Windows.Media.Brushes.Red.Color;
            //tChart1.Axes.Left.TickOnLabelsOnly = false;
            //tChart1.Axes.Left.Labels.Visible = false;

            //tChart1.Axes.Left.TickOnLabelsOnly = false;
            //tChart1.Axes.Left.Labels.Visible = false;
        }

        private void PastCursorTool_Change(object sender, CursorChangeEventArgs e)
        {
            foreach (Series s in tChart1.Series)
            {
                var value1 = DateTime.FromOADate(e.XValue).ToString("HH:mm:ss");
                var value2 = (e.YValue).ToString();
            }
        }

        int data = 70;
        void timer_Tick(object sender, EventArgs e)
        {
            TrendWidgetStartTime=TrendWidgetStartTime.AddSeconds(1);
            TrendWidgetEndTime = TrendWidgetEndTime.AddSeconds(1);

            TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);
            ViewStartTime = DateTime.Now;
            Random rnd = new Random();
            int n = rnd.Next(1, 5);
            line.Add(DateTime.Now, data, "");

            if (data == 70) data = 50;
            else data = 70;

            txtBlock.Text = DateTime.Now.ToString() + ":" + n;
            onedayMins = onedayMins + ((double)RefreshCycle / 60);
            double newBoederWidth = brdInsideScroll.Width = (tsp.TotalMinutes * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
            pastCursorTool.XValue = DateTime.Now.ToOADate();
            currentCursorTool.XValue = DateTime.Now.ToOADate();
            tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
            UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));
            scrollBarBottom.ScrollToRightEnd();

        }

        int RefreshCycle = 60;
        void UpdateStartEndDate(DateTime startDate, DateTime endDate)
        {
            //txtStartDate.Text = startDate.ToString("dd MMM yyyy");
            //txtEndDate.Text = endDate.ToString("dd MMM yyyy"); ;

            txtStartDate.Text = startDate.ToString();
            txtEndDate.Text = endDate.ToString();
            
        }

        bool isScrollAtEnd = false;//Test
        private void scrollBarBottom_ScrollChanged_1(object sender, ScrollChangedEventArgs e)
        {
            //Console.WriteLine("SC_Changed:" + (scrollBarBottom.HorizontalOffset));

            //txtTest.Text = txtTest.Text + ":" + scrollBarBottom.HorizontalOffset.ToString() + ":";
            //MessageBox.Show(""+scrollBarBottom.HorizontalOffset);

            double min = scrollBarBottom.HorizontalOffset / oneMinWidth;

            if (scrollBarBottom.IsMouseCaptureWithin == true)
            {
                //txtTest.Text = DateTime.Now.ToString() + " Count:" + count;


                //this.Dispatcher.BeginInvoke(new textupdater(UpdateText),DispatcherPriority.Render, null);
                if (scrollBarBottom.HorizontalOffset == scrollBarBottom.ScrollableWidth || scrollBarBottom.HorizontalOffset == 0)
                {
                    isScrollAtEnd = true;
                    if (scrollBarBottom.HorizontalOffset == scrollBarBottom.ScrollableWidth)
                    {
                        TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);
                        //ViewStartTime = DateTime.Now;
                        ViewStartTime = TrendWidgetStartTime.AddMinutes(min);
                        brdInsideScroll.Width = (tsp.TotalMinutes * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
                        pastCursorTool.XValue = DateTime.Now.ToOADate();
                        currentCursorTool.XValue = DateTime.Now.ToOADate();
                        tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
                        UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));
                        //return;
                    }
                }
                else
                {
                    isScrollAtEnd = false;
                }
                ViewStartTime = TrendWidgetStartTime.AddMinutes(min);
                ViewEndTime = TrendWidgetStartTime.AddMinutes(min + totalMins);
                tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.AddMinutes(min).ToOADate(), TrendWidgetStartTime.AddMinutes(min + totalMins).ToOADate());
                UpdateStartEndDate(TrendWidgetStartTime.AddMinutes(min), TrendWidgetStartTime.AddMinutes(min + totalMins));

                string dateTimeString = ViewStartTime.ToString("g");


                bool bFound = Points.Exists(x => x.DateTime.ToString("g") == dateTimeString);
                if (bFound)
                {
                    //MessageBox.Show(bFound.ToString() + ":" + dateTimeString);
                }
                //if (backgroundWorker.IsBusy == false)
                //{
                //    backgroundWorker.RunWorkerAsync(ViewStartTime);

                //}
                if (e.HorizontalChange > 0)//Right Drag
                {
                    //TimeSpan tsp1 = Points[Points.Count - 1].DateTime.Subtract(ViewEndTime);
                    //TimeSpan tsp1 = ViewEndTime.Subtract(Points[Points.Count-1].DateTime.AddDays(-30));


                    TimeSpan tsp1 = TR_END_TIME.Subtract(ViewEndTime);
                    if (tsp1.TotalHours<= (HISTORYREADHOURS / 3))
                    {
                        TR_START_TIME = ViewStartTime.AddHours((-HISTORYREADHOURS / 2));
                        TR_END_TIME = ViewEndTime.AddHours((HISTORYREADHOURS / 2));
                        MessageBox.Show("ViewEndTime:" + ViewEndTime.ToString() + "-Point[Points.Count-1]:" + Points[Points.Count - 1].DateTime.ToString() + "-Days:" + tsp1.ToString());
                        DateTime _firstDateTime = Points[Points.Count - 1].DateTime;

                        TimeSpan tsp = _firstDateTime.AddMonths(2).Subtract(_firstDateTime);

                        if (_firstDateTime.AddMonths(2) > DateTime.Now)
                        {

                        }
                        List<TrendData> tempList = new List<TrendData>();
                        for (int i = 0; i < tsp.Days * 1440; i++)
                        {
                            tempList.Add(new TrendData(_firstDateTime.AddMonths(2).AddMinutes(i), -10));
                            tempList.Add(new TrendData(_firstDateTime.AddMonths(2).AddMinutes(i), rnd.Next(75, 80)));
                        }
                        Points.AddRange(tempList);
                        line.DataSource = Points;
                        line.Invalidate();

                    }
                }
                else //Left Drag
                {
                    //TimeSpan tsp1 = ViewStartTime.Subtract(Points[0].DateTime);
                   //DateTime tsp11 = ViewStartTime.AddHours(-HISTORYREADHOURS/3);
                    //TimeSpan tsp1 = ViewStartTime.Subtract(ViewStartTime.AddHours(HISTORYREADHOURS/3));

                   TimeSpan tsp1 = ViewStartTime.Subtract(TR_START_TIME);
                   if (tsp1.TotalHours <= HISTORYREADHOURS / 3)
                   {
                       //TR_END_TIME = TR_START_TIME.AddHours(((HISTORYREADHOURS)/3)*2);
                       // TR_START_TIME = TR_START_TIME.AddHours((-HISTORYREADHOURS / 3));
                       // //TR_END_TIME = TR_START_TIME.AddHours((HISTORYREADHOURS));


                       TR_START_TIME = ViewStartTime.AddHours((-HISTORYREADHOURS / 2));
                       TR_END_TIME = ViewEndTime.AddHours((HISTORYREADHOURS / 2));

                        //Thread.Sleep(new TimeSpan(0,0,30));
                        txtBlock.Text = Points[0].DateTime.ToString();

                        //e.Handled = true;
                        MessageBox.Show("ViewStartTime:" + ViewStartTime.ToString() + "-Point[0]:" + Points[0].DateTime.ToString() + "-Days:" + tsp1.ToString());
                        List<TrendData> tempList = new List<TrendData>();
                        DateTime _firstDateTime = Points[0].DateTime;
                        TimeSpan tsp = _firstDateTime.Subtract(_firstDateTime.AddMonths(-2));
                        for (int i = 0; i < tsp.Days * 1440; i++)
                        {
                            tempList.Add(new TrendData(_firstDateTime.AddMonths(-2).AddMinutes(i), -10));
                            tempList.Add(new TrendData(_firstDateTime.AddMonths(-2).AddMinutes(i), rnd.Next(75, 80)));
                        }
                        tempList.AddRange(Points);
                        Points = tempList;


                        DateTime _viewEndTime = ViewEndTime.AddMonths(1);
                        TrendData trendData = Points.Where(x => x.DateTime > _viewEndTime).FirstOrDefault();
                        int _index = Points.IndexOf(trendData);
                        Points.RemoveRange(_index, Points.Count - _index);

                        List<TrendData> dataSource = line.DataSource as List<TrendData>;
                        if (dataSource == null)
                        {
                            dataSource = Points;
                        }

                        line.DataSource = null;
                        line.Clear();
                        line.XValues.Clear();
                        line.YValues.Clear();
                        
                        line.DataSource = dataSource;
                        line.Invalidate();

                        //line.DataSource = Points;
                        //line.Invalidate();

                        //int _index=Points.(x => x.DateTime > _viewEndTime);
                    }
                }

            }
            //txtTest.Text = tsp1.ToString();

        }

        delegate void textupdater();


        BackgroundWorker backgroundWorker;


        private void UpdateText()
        {
            try
            {
                for (int i = 0; i < 10000000; i++)
                {
                    txtTest.Text = i.ToString();
                }
            }
            catch (Exception ex)
            {

            }
        }

        int scaleX = 0;
        const int MaxXAxisScale = 5;
        const int MinXAxisScale = 0;

        private void btnZoomX_Click_1(object sender, RoutedEventArgs e)
        {
            string Scale = (sender as Button).Content.ToString();


            previoustotalMins = totalMins;

            switch (Scale)
            {
                case "00:15"://45min 9 5min
                    totalMins = 15;
                    break;
                case "00:30"://1hr30min 6 15 min

                    totalMins = 30;
                    break;
                case "01:00"://3hrs 6 30min
                    totalMins = 60;
                    break;
                case "04:00"://6hrs 6 1hr

                    totalMins = 240;
                    break;
                case "12:00"://12hrs 6 2hr
                    totalMins = 720;

                    break;
                case "24:00"://1day 8 3hrs
                    totalMins = 1440;

                    break;
                default:
                    break;
            }


        }

        double _previousTotalMinutes;
        private void btnZoomIn_Click_1(object sender, RoutedEventArgs e)
        {
            TimeSpan tsp = DateTime.Now.Subtract(TrendWidgetStartTime);
            scaleX++;
            ScaleXAxis(scaleX);
            btnZoomOut.IsEnabled = true;
            if (scaleX == MaxXAxisScale)
            {
                btnZoomIn.IsEnabled = false;
            }

            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;
            oneMinWidth = tChart1.Chart.ChartRect.Width / totalMins;
            oneDayWidth = oneMinWidth * onedayMins;
            //double newBoederWidth = brdInsideScroll.Width = (oneYearMins * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
            //double newBoederWidth = brdInsideScroll.Width = (tsp.TotalMinutes * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);
            TimeSpan time = DateTime.Now.Subtract(TrendWidgetStartTime);

            double newBoederWidth = brdInsideScroll.Width = (time.TotalMinutes * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);

            _previousTotalMinutes = totalMins;


            TrendWidgetEndTime = TrendWidgetStartTime.AddMinutes((oneYearMins + (totalMins / 4)));

            if (isScrollAtEnd == true && scrollBarBottom.HorizontalOffset == scrollBarBottom.ScrollableWidth)
            {
                scrollBarBottom.ScrollToRightEnd();
                tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
                UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));

            }
            else if (isScrollAtEnd == true && scrollBarBottom.HorizontalOffset == 0)
            {
                scrollBarBottom.ScrollToLeftEnd();
                tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.ToOADate(), TrendWidgetStartTime.AddMinutes(totalMins).ToOADate());
                UpdateStartEndDate(TrendWidgetStartTime, TrendWidgetStartTime.AddMinutes(totalMins));
            }
            else //if (scrollBarBottom.HorizontalOffset != scrollBarBottom.ScrollableWidth)
            {
                ViewStartTime = ViewStartTime.AddMinutes(-totalMins / 2);
                time = ViewStartTime.Subtract(TrendWidgetStartTime);
                if (TrendWidgetStartTime < ViewStartTime && ViewStartTime.AddMinutes(totalMins) < TrendWidgetEndTime)
                {
                    scrollBarBottom.ScrollToHorizontalOffset(time.TotalMinutes * oneMinWidth);
                    tChart1.Axes.Bottom.SetMinMax(ViewStartTime.ToOADate(), ViewStartTime.AddMinutes(totalMins).ToOADate());
                    UpdateStartEndDate(ViewStartTime, ViewStartTime.AddMinutes(totalMins));
                }
                else if (ViewStartTime.AddMinutes(totalMins) > TrendWidgetEndTime)
                {
                    scrollBarBottom.ScrollToRightEnd();
                    tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
                    UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));
                }
                else
                {
                    scrollBarBottom.ScrollToLeftEnd();
                    tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.ToOADate(), TrendWidgetStartTime.AddMinutes(totalMins).ToOADate());
                    UpdateStartEndDate(TrendWidgetStartTime, TrendWidgetStartTime.AddMinutes(totalMins));
                }

            }
        }

        private void btnZoomOut_Click_1(object sender, RoutedEventArgs e)
        {
            scaleX--;
            ScaleXAxis(scaleX);
            btnZoomIn.IsEnabled = true;
            if (scaleX == MinXAxisScale)
            {
                btnZoomOut.IsEnabled = false;
            }
            scrollBarBottom.Width = tChart1.Chart.ChartRect.Width;
            oneMinWidth = tChart1.Chart.ChartRect.Width / totalMins;
            oneDayWidth = oneMinWidth * onedayMins;
            double newBoederWidth = brdInsideScroll.Width = (oneYearMins * oneMinWidth) + (((totalMins / 4)) * oneMinWidth);

            TrendWidgetEndTime = TrendWidgetStartTime.AddMinutes((oneYearMins + (totalMins / 4)));

            if (isScrollAtEnd == true && scrollBarBottom.HorizontalOffset == scrollBarBottom.ScrollableWidth)
            {
                scrollBarBottom.ScrollToRightEnd();
                tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
                UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));

            }
            else if (isScrollAtEnd == true && scrollBarBottom.HorizontalOffset == 0)
            {
                scrollBarBottom.ScrollToLeftEnd();
                tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.ToOADate(), TrendWidgetStartTime.AddMinutes(totalMins).ToOADate());
                UpdateStartEndDate(TrendWidgetStartTime, TrendWidgetStartTime.AddMinutes(totalMins));
            }
            else
            {
                ViewStartTime = ViewStartTime.AddMinutes(_previousTotalMinutes / 2);
                TimeSpan time = ViewStartTime.Subtract(TrendWidgetStartTime);
                if (TrendWidgetStartTime < ViewStartTime && ViewStartTime.AddMinutes(totalMins) < TrendWidgetEndTime)
                {
                    scrollBarBottom.ScrollToHorizontalOffset(time.TotalMinutes * oneMinWidth);
                    tChart1.Axes.Bottom.SetMinMax(ViewStartTime.ToOADate(), ViewStartTime.AddMinutes(totalMins).ToOADate());
                    UpdateStartEndDate(ViewStartTime, ViewStartTime.AddMinutes(totalMins));
                }
                else if (ViewStartTime.AddMinutes(totalMins) > TrendWidgetEndTime)
                {
                    scrollBarBottom.ScrollToRightEnd();
                    tChart1.Axes.Bottom.SetMinMax(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)).ToOADate(), DateTime.Now.AddMinutes(((totalMins / 4))).ToOADate());
                    UpdateStartEndDate(DateTime.Now.AddMinutes(-((totalMins / 4) * 3)), DateTime.Now.AddMinutes(((totalMins / 4))));
                }
                else
                {
                    scrollBarBottom.ScrollToLeftEnd();
                    tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.ToOADate(), TrendWidgetStartTime.AddMinutes(totalMins).ToOADate());
                    UpdateStartEndDate(TrendWidgetStartTime, TrendWidgetStartTime.AddMinutes(totalMins));
                }

            }
            _previousTotalMinutes = totalMins;

        }
        private void ScaleXAxis(int Scale)
        {
            switch (Scale)
            {
                case 0://45min 9 5min

                    totalMins = 15;

                    break;
                case 1://1hr30min 6 15 min

                    totalMins = 30;


                    break;
                case 2://3hrs 6 30min

                    totalMins = 60;


                    break;
                case 3://6hrs 6 1hr

                    totalMins = 240;


                    break;
                case 4://12hrs 6 2hr

                    totalMins = 720;


                    break;
                case 5://1day 8 3hrs
                    totalMins = 1440;

                    break;
                default:
                    break;
            }

        }

        private void btnStartPause_Click_1(object sender, RoutedEventArgs e)
        {
            DateTime dt = DateTime.FromOADate(41592.413788561862);
        }

        int h=7;
        private void btnSet_Click_1(object sender, RoutedEventArgs e)
        {
            timer.Stop();
            int min1 = h * 60;
            double d = oneMinWidth * min1;
            Console.WriteLine("d:" + d);
            Console.WriteLine("Before:"+scrollBarBottom.HorizontalOffset);
            double min = (scrollBarBottom.HorizontalOffset-d) / oneMinWidth;
            scrollBarBottom.ScrollToHorizontalOffset(scrollBarBottom.HorizontalOffset-d);
            Console.WriteLine("After:" + (scrollBarBottom.HorizontalOffset - d));
            ViewStartTime = TrendWidgetStartTime.AddMinutes(min);
            ViewEndTime = TrendWidgetStartTime.AddMinutes(min + totalMins);
            tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.AddMinutes(min).ToOADate(), TrendWidgetStartTime.AddMinutes(min + totalMins).ToOADate());
            UpdateStartEndDate(TrendWidgetStartTime.AddMinutes(min), TrendWidgetStartTime.AddMinutes(min + totalMins));

        }

        private void btnSet_Click_2(object sender, RoutedEventArgs e)
        {
            int min1 = h * 60;
            double d = oneMinWidth * min1;
            Console.WriteLine("d:" + d);
            Console.WriteLine("Before:" + scrollBarBottom.HorizontalOffset);
            double min = (scrollBarBottom.HorizontalOffset + d) / oneMinWidth;
            scrollBarBottom.ScrollToHorizontalOffset(scrollBarBottom.HorizontalOffset + d);
            Console.WriteLine("After:" + (scrollBarBottom.HorizontalOffset + d));
            ViewStartTime = TrendWidgetStartTime.AddMinutes(min);
            ViewEndTime = TrendWidgetStartTime.AddMinutes(min + totalMins);
            tChart1.Axes.Bottom.SetMinMax(TrendWidgetStartTime.AddMinutes(min).ToOADate(), TrendWidgetStartTime.AddMinutes(min + totalMins).ToOADate());
            UpdateStartEndDate(TrendWidgetStartTime.AddMinutes(min), TrendWidgetStartTime.AddMinutes(min + totalMins));

        }


    }
}
